package com.base.locationsharewhite.location

import com.base.locationsharewhite.GlobalConfig
import com.base.locationsharewhite.helper.AESHelper
import com.base.locationsharewhite.helper.ReportUtils
import com.base.locationsharewhite.utils.LogEx
import org.json.JSONObject

/**
 * 改变别人是否可以看我的状态接口
 */
object LocationStatusUtils {

    private val TAG = "LocationStatusUtils"

    /**
     * 改变别人是否可以看我的状态接口
     */
    private val url by lazy {
        val pkg = GlobalConfig.PACKAGE_NAME
        val url = StringBuilder(
            "${GlobalConfig.URL_API}/dingwei/${pkg.filter { it.isLowerCase() }.substring(4, 9)}f"
        )
        url.append("?pkg=$pkg")
        url.toString()
    }

    fun changeViewerStatus(
        device: String,
        status: Int,
        callBack: (flag: Boolean) -> Unit
    ) {
        Thread {
            val data = JSONObject()
            data.put("device", device)
            data.put("status", status)

            val bp = BpUtils.getBp()

            val body = JSONObject()
                .put("data", data)
                .put("bp", bp)
                .toString()
            val paramJson = AESHelper.encrypt(body)
            LogEx.logDebug(TAG, "paramJson=$paramJson")
            runCatching {
                val result = ReportUtils.doPost(url, HashMap(), paramJson)
                LogEx.logDebug(TAG, "result=$result")
                val responseData = LocationLoginUtils.extractData(result)
                LogEx.logDebug(TAG, "responseData=$responseData")
                if (responseData != null) {
                    val state = AESHelper.decrypt(responseData).toBoolean()
                    callBack.invoke(state)
                } else {
                    callBack.invoke(false)
                }
            }
        }.start()
    }
}